unit Cor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, ColorGrd;

type
  TForm1 = class(TForm)
    PanCor: TPanel;
    FecCor: TSpeedButton;
    BarCor: TLabel;
    OkCor: TSpeedButton;
    BevCor2: TBevel;
    BevCor1: TBevel;
    CorBas: TImage;
    LabRed: TLabel;
    LabGreen: TLabel;
    LabBlue: TLabel;
    EdtRed: TEdit;
    EdtGreen: TEdit;
    EdtBlue: TEdit;
    GrayPic: TImage;
    GrayBar: TScrollBar;
    GiroCor: TSpeedButton;
    BarRed: TScrollBar;
    BarGre: TScrollBar;
    BarBlu: TScrollBar;
    QuePap: TPanel;
    QueInk: TPanel;
    TruCor: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LabTest: TLabel;
    SpeedButton1: TSpeedButton;
    procedure BarCorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BarCorMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BarCorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FecCorClick(Sender: TObject);
    procedure CorBasMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TruCorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GiroCorClick(Sender: TObject);
    procedure GrayBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure BarGreScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure BarBluScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure BarRedScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure EdtRedExit(Sender: TObject);
    procedure EdtRedKeyPress(Sender: TObject; var Key: Char);
    procedure EdtGreenKeyPress(Sender: TObject; var Key: Char);
    procedure EdtGreenExit(Sender: TObject);
    procedure EdtBlueExit(Sender: TObject);
    procedure EdtBlueKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}
{--- Declaraes de variveis e constantes globais --------------}
const
   Ink: longint = 0;
   Paper: longint = $00FFFFFF;
   TCor: longint = 0;
   Red: longint = 0;
   Green: longint = 0;
   Blue: longint = 0;
   Gray: integer = 0;

var
   Lx,Ly: word;
   Lk: byte;

{=== Incio do controle PANCOR : Seletor de cor para Paper e Ink }
procedure DecodeCor;
begin
   Red:= Ink and $000000FF;
   Green:= 0;
   if (Ink and $0000FF00) <> 0 then Green:= (Ink and $0000FF00) div 256;
   Blue:= 0;
   if (Ink and $00FF0000) <> 0 then Blue:= (Ink and $00FF0000) div 65536;
end;

procedure CodeCor;
begin
   Ink:= (Blue * 65536) + (Green * 256) + Red;
   if Ink < 0 then Ink:= Ink and $00FFFFFF;
end;

procedure MostraCor;
begin
   Form1.QuePap.Color:= Paper; Form1.QueInk.Color:= Ink;
   DecodeCor;
   Form1.EdtBlue.Text:= IntToStr(Blue); Form1.BarBlu.Position:= Blue;
   Form1.EdtGreen.Text:= IntToStr(Green); Form1.BarGre.Position:= Green;
   Form1.EdtRed.Text:= IntToStr(Red); Form1.BarRed.Position:= Red;
end;

procedure TForm1.FecCorClick(Sender: TObject);
begin
   PanCor.Visible:= False;
   LabTest.Font.Color:= Ink;
   LabTest.Color:= Paper;
end;

procedure TForm1.BarCorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Lx:= X; Ly:= Y; Lk:= 1;
end;

procedure TForm1.BarCorMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if Lk = 1 then begin
      if X > Lx then PanCor.Left:= PanCor.Left + (X - Lx);
      if X < Lx then PanCor.Left:= PanCor.Left - (Lx - X);
      if Y > Ly then PanCor.Top:= PanCor.Top + (Y - Ly);
      if Y < Ly then PanCor.Top:= PanCor.Top - (Ly - Y);
   end;
end;

procedure TForm1.BarCorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Lk:= 0;
end;

procedure TForm1.CorBasMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
   DefCor: array [0..15] of longint = (
           $00000000,$00800000,$00008000,$00808000,
           $00000080,$00800080,$00008080,$00C0C0C0,
           $00808080,$00FF0000,$0000FF00,$00FFFF00,
           $000000FF,$00FF00FF,$0000FFFF,$00FFFFFF);
begin
   TCor:= 0;
   if Y <> 0 then TCor:= (Y div 16) * 4;
   if X <> 0 then TCor:= TCor + (X div 16);
   Ink:= DefCor[TCor];
   Form1.GrayBar.Position:= 0; Gray:= 0; MostraCor;
end;

procedure TForm1.TruCorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Ink:= TruCor.Canvas.Pixels[X,Y];
   Form1.GrayBar.Position:= 0; Gray:= 0; MostraCor;
end;

procedure TForm1.GiroCorClick(Sender: TObject);
begin
   TCor:= Ink; Ink:= Paper; Paper:= TCor;
   Form1.GrayBar.Position:= 0; Gray:= 0; MostraCor;
end;

procedure TForm1.BarGreScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
   DecodeCor; Green:= BarGre.Position; CodeCor; MostraCor;
end;

procedure TForm1.BarBluScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
   DecodeCor; Blue:= BarBlu.Position; CodeCor; MostraCor;
end;

procedure TForm1.BarRedScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
   DecodeCor; Red:= BarRed.Position; CodeCor; MostraCor;
end;

procedure TForm1.GrayBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
   DecodeCor;
   if GrayBar.Position > Gray then begin
      inc(Red,(GrayBar.Position-Gray));
      inc(Green,(GrayBar.Position-Gray));
      inc(Blue,(GrayBar.Position-Gray)); end;
   if GrayBar.Position < Gray then begin
      dec(Red,(Gray-GrayBar.Position));
      dec(Green,(Gray-GrayBar.Position));
      dec(Blue,(Gray-GrayBar.Position)); end;
   if Red > 255 then Red:= 255; if Red < 0 then Red:= 0;
   if Blue > 255 then Blue:= 255; if Blue < 0 then Blue:= 0;
   if Green > 255 then Green:= 255; if Green < 0 then Green:= 0;
   Gray:= GrayBar.Position; CodeCor; MostraCor;
end;

procedure TForm1.EdtRedExit(Sender: TObject);
begin
   DecodeCor;
   try Red:= StrToInt(EdtRed.Text);
   except Red:= 0;
   end;
   CodeCor; MostraCor;
end;

procedure TForm1.EdtRedKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then begin
   DecodeCor;
   try Red:= StrToInt(EdtRed.Text);
   except Red:= 0;
   end;
   CodeCor; MostraCor;
   end;
end;

procedure TForm1.EdtGreenKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then begin
   DecodeCor;
   try Green:= StrToInt(EdtRed.Text);
   except Green:= 0;
   end;
   CodeCor; MostraCor;
   end;
end;

procedure TForm1.EdtGreenExit(Sender: TObject);
begin
   DecodeCor;
   try Green:= StrToInt(EdtRed.Text);
   except Green:= 0;
   end;
   CodeCor; MostraCor;
end;

procedure TForm1.EdtBlueExit(Sender: TObject);
begin
   DecodeCor;
   try Blue:= StrToInt(EdtRed.Text);
   except Blue:= 0;
   end;
   CodeCor; MostraCor;
end;

procedure TForm1.EdtBlueKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then begin
   DecodeCor;
   try Blue:= StrToInt(EdtRed.Text);
   except Blue:= 0;
   end;
   CodeCor; MostraCor;
   end;
end;

{=== Fim do controle PANCOR =====================================}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    PanCor.Visible:= True;
    MostraCor;
end;

end.
